Merged revisions 115285 via svnmerge from
[asterisk/asterisk.git] / contrib / init.d / rc.suse.asterisk
1 #!/bin/sh
2 # $Id: asterisk,v 1.3 2005/11/17 22:30:01 Gregory Boehnlein <damin@nacs.net>
3 #
4 # asterisk    Starts, Stops and Reloads Asterisk.
5 #
6 # chkconfig: 2345 40 60
7 # description: Asterisk PBX and telephony daemon.
8 # processname: asterisk
9 # pidfile: /var/run/asterisk.pid
10 #
11 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
12 # - Updated Version to 1.3
13 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
14 # - Added detailed failure messages
15 #
16 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
17 # - Updated Version to 1.2
18 # - Added test for safe_asterisk
19 # - Verified SIGTERM issued by "killproc" ensures "stop gracefully"
20 # - Added support for -U and -G command line options
21 # - Modified "reload" to call asterisk -rx 'reload' 
22
23 ### BEGIN INIT INFO
24 # Provides:                    asterisk
25 # Required-Start:      +zaptel $network $named
26 # Required-Stop:
27 # Default-Start:     3 5
28 # Default-Stop:      0 1 2 4 6
29 # Description: zaptel - zaptel modules for Asterisk
30 ### END INIT INFO
31
32 # Source function library.
33 . /lib/lsb/init-functions
34
35 if ! [ -x /usr/sbin/asterisk ] ; then
36         echo "ERROR: /usr/sbin/asterisk not found"
37         exit 0
38 fi
39
40 if ! [ -d /etc/asterisk ] ; then
41         echo "ERROR: /etc/asterisk directory not found"
42         exit 0
43 fi
44
45 # Uncomment this ONLY if you know what you are doing.
46 # export LD_ASSUME_KERNEL=2.4.1
47
48 # Full path to asterisk binary
49 DAEMON=/usr/sbin/asterisk
50
51 # Full path to safe_asterisk script
52 SAFE_ASTERISK=/usr/sbin/safe_asterisk
53
54 # Uncomment the following and set them to the user/groups that you
55 # want to run Asterisk as. NOTE: this requires substantial work to
56 # be sure that Asterisk's environment has permission to write the
57 # files required  for  its  operation, including logs, its comm
58 # socket, the asterisk database, etc.
59 #AST_USER="asterisk"
60 #AST_GROUP="asterisk"
61
62 RETVAL=0
63
64 start() {
65         # Start daemons.
66
67         # Check if Asterisk is already running.  If it is, then bug out, because
68         # starting Asterisk when Asterisk is already running is very bad.
69         VERSION=`/usr/sbin/asterisk -rx 'core show version'`
70         if [ "${VERSION:0:8}" = "Asterisk" ]; then # otherwise "Unable t"
71                 echo "Asterisk is already running.  $0 will exit now."
72                 exit 1
73         fi
74
75         echo -n $"Starting asterisk: "
76         if [ -f $SAFE_ASTERISK ] ; then
77                 DAEMON=$SAFE_ASTERISK
78         fi
79         if [ $AST_USER ] ; then
80                 ASTARGS="-U $AST_USER"
81         fi
82         if [ $AST_GROUP ] ; then
83                 ASTARGS="`echo $ASTARGS` -G $AST_GROUP"
84         fi
85         $DAEMON $ASTARGS
86         RETVAL=$?
87         [ $RETVAL -eq 0 ] && touch /var/lock/subsys/asterisk
88         echo
89         return $RETVAL
90 }
91
92 stop() {
93         # Stop daemons.
94         echo -n $"Shutting down asterisk: "
95         killproc asterisk
96         RETVAL=$?
97         [ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/asterisk
98         echo
99         return $RETVAL
100 }
101
102 restart() {
103         stop
104         start
105 }
106
107 reload() {
108         $DAEMON -rx 'reload' > /dev/null 2> /dev/null
109 }
110
111 # See how we were called.
112 case "$1" in
113   start)
114         start
115         ;;
116   stop)
117         stop
118         ;;
119   restart)
120         restart
121         ;;
122   reload)
123         reload
124         ;;
125   condrestart)
126         [ -f /var/lock/subsys/asterisk ] && restart || :
127         ;;
128   status)
129         status asterisk
130         ;;
131   *)
132         echo "Usage: asterisk {start|stop|restart|reload|condrestart|status}"
133         exit 1
134 esac
135
136 exit $?